# Blobbit/Gloopy, a platformer video game
# Copyright (C) 2007  Christopher Allan Webber and Jeff Gibson
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from worldsprite import WorldSprite

class Item(WorldSprite):
  def __init__(self, lower_x, lower_y, engine, image):
    WorldSprite.__init__(self, lower_x, lower_y, engine, image)

class Vial(Item):
  def __init__(self, lower_x, lower_y, engine):
    WorldSprite.__init__(self, lower_x, lower_y, engine, engine.images['vial'])
    self.rect.left += 14
    self.rect.bottom -= 6

  def update(self):
    player = self.engine.player.sprites()[0]
    if self.rect.colliderect(player.colliderect):
      player.increase_mass(10)
      self.kill()
