# Blobbit/Gloopy, a platformer video game
# Copyright (C) 2007  Christopher Allan Webber and Jeff Gibson
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import pygame
from pygame import *
import tiles
import monsters
import items
import player

class LevelParse:
  def __init__(self, engine):
    # set the dictionary of char to classes here?
    self.tile_map = {
      '.': tiles.Metal,
      #'g': tiles.Grate,
      'i': tiles.Ice,
      'f': tiles.Fire,
    }
    self.monster_map = {
      #'F': monsters.FlipFlap,
      #'R': monsters.Robo,
      #'S': monsters.Splotch,
      'D': monsters.Drakko,
    }
    self.item_map = {
      'v': items.Vial,
    }

    self.engine = engine

  def Parse(self, level):
    all_tiles = pygame.sprite.Group()
    all_monsters = pygame.sprite.Group()
    all_items = pygame.sprite.Group()
    all_players = pygame.sprite.Group()

    level_lines = open('levels/' + level, 'r').readlines()

    getxy = lambda x,y: (x * 48, y * 48)

    # grab the bottommost pixel for the bottom boundary
    _, self.engine.level.bottom_pixel = getxy(0, len(level_lines))

    y = 1 # set the iterator for the y axis
    for row in level_lines:
      x = 0 # set the iterator for the x axis
      for column in row.rstrip():
        if column != ' ':
          gotx, goty = getxy(x, y)
          # if this is the rightmost found tile, let's mark it
          if goty > self.engine.level.rightmost_pixel:
            self.engine.level.rightmost_pixel = gotx

          if self.monster_map.get(column):
            monster = self.monster_map[column](gotx, goty, self.engine)
            all_monsters.add(monster)
          elif self.item_map.get(column):
            item = self.item_map[column](gotx, goty, self.engine)
            all_items.add(item)
          elif self.tile_map.get(column):
            tile = self.tile_map[column](gotx, goty, self.engine)
            all_tiles.add(tile)
          elif column == '@':
            blobbit = player.Blobbit(gotx, goty, self.engine)
            all_players.add(blobbit)
          else:
            print 'Houston we have a problem.  Your target isnt in the map'

        x += 1
      y += 1

    return all_tiles, all_monsters, all_items, all_players
