# Blobbit/Gloopy, a platformer video game
# Copyright (C) 2007  Christopher Allan Webber and Jeff Gibson
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from worldsprite import WorldSprite

class Tile(WorldSprite):
  def __init__(self, lower_x, lower_y, engine, image):
    WorldSprite.__init__(self, lower_x, lower_y, engine, image)

class Metal(Tile):
  def __init__(self, lower_x, lower_y, engine):
    Tile.__init__(self, lower_x, lower_y, engine, engine.images['metal'])

class Ice(Tile):
  def __init__(self, lower_x, lower_y, engine):
    Tile.__init__(self, lower_x, lower_y, engine, engine.images['ice'])

  def fry_self(self):
    self.engine.sounds['ice_break'].play()
    self.kill()

class Fire(Tile):
  def __init__(self, lower_x, lower_y, engine):
    Tile.__init__(self, lower_x, lower_y, engine, engine.images['fire1'])
